package cn.com.ctop.alarm.modules.controller;

import cn.com.ctop.alarm.modules.entity.RuleBase;
import cn.com.ctop.alarm.modules.service.IRuleAccountThresholdService;
import cn.com.ctop.alarm.modules.service.IRuleBaseService;
import cn.com.ctop.common.module.annotation.AutoLog;
import cn.com.ctop.common.module.utils.QueryGenerator;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.util.oConvertUtils;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 基础规则
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2020-11-15
 */
@Slf4j
@Api(tags = "基础规则")
@RestController
@RequestMapping("/ruleBase")
public class RuleBaseController {
    @Autowired
    private IRuleBaseService ruleBaseService;
    @Autowired
    private IRuleAccountThresholdService ruleAccountThresholdService;

    /**
     * 分页列表查询
     *
     * @param ruleBase
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @AutoLog(value = "基础规则-分页列表查询")
    @ApiOperation(value = "基础规则-分页列表查询", notes = "基础规则-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<RuleBase>> queryPageList(RuleBase ruleBase,
                                                 @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                 @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                 HttpServletRequest req) {
        Result<IPage<RuleBase>> result = new Result<>();
        QueryWrapper<RuleBase> queryWrapper = QueryGenerator.initQueryWrapper(ruleBase, req.getParameterMap());
        Page<RuleBase> page = new Page<RuleBase>(pageNo, pageSize);
        IPage<RuleBase> pageList = ruleBaseService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param ruleBase
     * @return
     */
    @AutoLog(value = "基础规则-添加")
    @ApiOperation(value = "基础规则-添加", notes = "基础规则-添加")
    @PostMapping(value = "/add")
    public Result<RuleBase> add(@RequestBody RuleBase ruleBase) {
        Result<RuleBase> result = new Result<>();
        try {
            ruleBaseService.save(ruleBase);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param ruleBase
     * @return
     */
    @AutoLog(value = "基础规则-编辑")
    @ApiOperation(value = "基础规则-编辑", notes = "基础规则-编辑")
    @PutMapping(value = "/edit")
    public Result<RuleBase> edit(@RequestBody RuleBase ruleBase) {
        Result<RuleBase> result = new Result<RuleBase>();
        RuleBase ruleBaseEntity = ruleBaseService.getById(ruleBase.getId());
        if (ruleBaseEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = ruleBaseService.updateById(ruleBase);
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "基础规则-通过id删除")
    @ApiOperation(value = "基础规则-通过id删除", notes = "基础规则-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            ruleBaseService.removeById(id);
            Map<String, Object> deleteMap = new HashMap<>();
            deleteMap.put("rule_id", id);
            ruleAccountThresholdService.removeByMap(deleteMap);


        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "基础规则-批量删除")
    @ApiOperation(value = "基础规则-批量删除", notes = "基础规则-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<RuleBase> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<RuleBase> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.ruleBaseService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @AutoLog(value = "基础规则-通过id查询")
    @ApiOperation(value = "基础规则-通过id查询", notes = "基础规则-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<RuleBase> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<RuleBase> result = new Result<>();
        RuleBase ruleBase = ruleBaseService.getById(id);
        if (ruleBase == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(ruleBase);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<RuleBase> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                RuleBase ruleBase = JSON.parseObject(deString, RuleBase.class);
                queryWrapper = QueryGenerator.initQueryWrapper(ruleBase, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<RuleBase> pageList = ruleBaseService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "基础规则列表");
        mv.addObject(NormalExcelConstants.CLASS, RuleBase.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("基础规则列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<RuleBase> listRuleBases = ExcelImportUtil.importExcel(file.getInputStream(), RuleBase.class, params);
                ruleBaseService.saveBatch(listRuleBases);
                return Result.ok("文件导入成功！数据行数:" + listRuleBases.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
